//
//  mdlInspectionItemResposne.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlInspectionItemResponse: Model, Content {
    static let schema = "inspectionItemResponse"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Parent(key: "inspectionItemId") var inspectionitem: mdlInspectionItem
    @Parent(key: "responseTypeId") var responsetype: mdlResponseType
    
    @Field(key: "name") var name: String?
    @Field(key: "sortOrder") var sortorder: Int?
    @Field(key: "isSelected") var isselected: Bool?
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         inspectionitemid: Int,
         responsetypeid: Int,
         name: String? = nil,
         sortorder: Int? = 0,
         isselected: Bool? = false,
         createuserid: Int? = nil,
         updateuserid: Int? = nil
    ) {
        self.id = id
        self.$inspectionitem.$id.value = inspectionitemid
        self.$responsetype.$id.value = responsetypeid
        self.name = name
        self.sortorder = sortorder
        self.isselected = isselected
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlInspectionItemResponse{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("inspectionItemResponse")
                .field("id", .int, .identifier(auto: true))
                .field("inspectionItemId", .int, .references("inspectionItem", "id"))
                .field("responseTypeId", .int, .references("responseType", "id"))
                .field("name", .string)
                .field("sortOrder", .int)
                .field("isSelected", .bool)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("inspectionItemResponse").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlInspectionItemResponse>{
        
        let query = mdlInspectionItemResponse.query(on: req.db)
            .with(\.$inspectionitem)
            .with(\.$responsetype)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

